import { Component, Input } from '@angular/core';
import { Group } from '../../shared/models/group';
import { GroupItemComponent } from "../group-item/group-item.component";
import { Policy } from '../../shared/models/policy';
import { GroupChatter } from '../../shared/models/group-chatter';

@Component({
  selector: 'group-list',
  standalone: true,
  imports: [GroupItemComponent],
  templateUrl: './group-list.component.html',
  styleUrl: './group-list.component.scss'
})
export class GroupListComponent {
  private _groups: { group: Group, chatters: GroupChatter[], policies: Policy[] }[] = [];
  private _filter: (item: { group: Group, chatters: GroupChatter[], policies: Policy[] }) => boolean = _ => true;


  get filter(): (item: { group: Group, chatters: GroupChatter[], policies: Policy[] }) => boolean {
    return this._filter;
  }

  @Input({ alias: 'filter', required: false })
  set filter(value: (item: { group: Group, chatters: GroupChatter[], policies: Policy[] }) => boolean) {
    this._filter = value;
  }

  get groups() {
    return this._groups.filter(this._filter);
  }

  @Input({ alias: 'groups', required: true })
  set groups(value: { group: Group, chatters: GroupChatter[], policies: Policy[] }[]) {
    this._groups = value;
  }
}